
Use [CI_SQLGroup_Demo]
Go

If Exists (	Select *
			From sys.indexes
			Where	name = 'ci_FactResellerSales'
					And type = 6
					And Object_id = Object_id('dbo.FactResellerSales')
			)
	DROP INDEX [ci_FactResellerSales] ON [dbo].[FactResellerSales];

--columns

CREATE NONCLUSTERED COLUMNSTORE INDEX [ci_FactResellerSales] 
ON [dbo].[FactResellerSales]
(
	[ProductKey],
	[OrderDateKey],
	[DueDateKey],
	[ShipDateKey],
	[ResellerKey],
	[EmployeeKey],
	[PromotionKey],
	[CurrencyKey],
	[SalesTerritoryKey],
	[SalesOrderNumber],
	[SalesOrderLineNumber],
	[RevisionNumber],
	[OrderQuantity],
	[UnitPrice],
	[ExtendedAmount],
	[UnitPriceDiscountPct],
	[DiscountAmount],
	[ProductStandardCost],
	[TotalProductCost],
	[SalesAmount],
	[TaxAmt],
	[Freight],
	[CarrierTrackingNumber],
	[CustomerPONumber],
	[OrderDate],
	[DueDate],
	[ShipDate]
);
GO


--create with 1024 cols

Declare @CreateTable as nvarchar(Max)
Set @CreateTable =	(
						Select ', COl' + Cast(Format(Number, '0000') as nvarchar(4)) + ' Int'
						From	master..spt_values
						Where	Type = 'P'
								And number between 1 and 1024
						For XML Path('')
					)

Set	 @CreateTable = 'Create Table With1024Columns ' + Stuff( @CreateTable, 1,1, '(') + ')'

If object_id('With1024Columns') is not null
	Drop table  With1024Columns

Exec (@CreateTable);


--create noclustered column store index
Declare @CreateIndex as nvarchar(Max)
Set @CreateIndex =	(
						Select ', COl' + Cast(Format(Number, '0000') as nvarchar(4))
						From	master..spt_values
						Where	Type = 'P'
								And number between 1 and 1024
						For XML Path('')
					)

Set	 @CreateIndex = 'Create nonclustered columnstore index  idx_With1024Columns_CI on  [dbo].[With1024Columns]' 
					+ Stuff( @CreateIndex, 1,1, '(') + ')'

Exec (@CreateIndex);

