Use [CI_SQLGroup_Demo]
GO

---Columnstore index size calculation in BOL (Not acurate);

SELECT SUM(on_disk_size_MB) AS TotalSizeInMB
FROM
(
   (SELECT SUM(css.on_disk_size)/(1024.0*1024.0) on_disk_size_MB
    FROM sys.indexes AS i
	    JOIN sys.partitions AS p
		        ON i.object_id = p.object_id 
		JOIN sys.column_store_segments AS css
        ON css.hobt_id = p.hobt_id
    WHERE i.object_id = object_id('FactResellerSalesbig') 
    AND i.type_desc = 'NONCLUSTERED COLUMNSTORE') 
  UNION ALL
   (SELECT SUM(csd.on_disk_size)/(1024.0*1024.0) on_disk_size_MB
    FROM sys.indexes AS i
    JOIN sys.partitions AS p
        ON i.object_id = p.object_id 
    JOIN sys.column_store_dictionaries AS csd
        ON csd.hobt_id = p.hobt_id
    WHERE i.object_id = object_id('FactResellerSalesbig') 
    AND i.type_desc = 'NONCLUSTERED COLUMNSTORE') 
) AS SegmentsPlusDictionary


-----Steven's Calculation (acurate per Eric Hanson, PM of columnstore indexes at Microsoft)

SELECT	SUM(s.used_page_count) / 128.0 on_disk_size_MB
FROM	sys.indexes AS i
		JOIN sys.dm_db_partition_stats AS S
			ON	i.object_id = S.object_id 
				and I.index_id = S.index_id
WHERE	i.object_id = object_id('FactResellerSalesBig') 
		AND i.type_desc = 'NONCLUSTERED COLUMNSTORE'

---Base table FactResellerSalesBig size = 2626 MB
---Nonclustered columnstore index IX_FactResellerSalesBig_NCI size = 251.69 MB
---Columnstore index comrpression ratio: 10.4 : 1


--Alter table FactResellerSalesBig_Compressed rebuild with (data_compression = Page)